package com.javacodegeeks.examples;

import static java.util.Objects.requireNonNull;
import static org.junit.jupiter.api.Assertions.*;

import java.lang.reflect.Field;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.core.annotation.AnnotationUtils;

import com.javacodegeeks.examples.annotation.MyAnnotation;

@SpringBootTest
class AliasForTest {
	
	@Autowired
	private ConfigurableApplicationContext context;

	@Test
	void testAtributeValues() {
		MyBean bean = context.getBean(MyBean.class);
		Class<?> objectClass = requireNonNull(bean).getClass();
		for (Field field : objectClass.getDeclaredFields()) {
			if (field.isAnnotationPresent(MyAnnotation.class)) {
				System.out.println("\nfield name: "+field.getName());
				MyAnnotation annotationOnBean = AnnotationUtils.findAnnotation(field, MyAnnotation.class);
				System.out.println("value for attribute \"value\": "+annotationOnBean.value());
				System.out.println("value for attribute \"name\": "+annotationOnBean.name());
				assertTrue(annotationOnBean.value().equals(annotationOnBean.name())
					, "The value and name attributes are not the same");
			}
		}
	}

}
